Bug 72604 - USB patch to allow Olympus digital cameras to work
USB patch to allow Olympus digital cameras to work
Status: CLOSED ERRATA
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
8.0
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Pete Zaitcev
Brian Brock
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-08-25 19:52 EDT by Frank Sweetser
Modified: 2007-04-18 12:46 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-06-03 06:16:13 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch for broken Olympus USB digital cameras (930 bytes, patch)
2002-08-25 19:53 EDT, Frank Sweetser
no flags Details | Diff

  None (edit)
Description Frank Sweetser 2002-08-25 19:52:29 EDT
Several Olympus USB digital cameras, including D-520 Zoom and D-150, do not work
under linux because the cameras send invalid checksum down the wire.  The
cameras work fine under MS Windows because it doesn't check this field.

A more detailed description of the problem is at
http://home.earthlink.net/~ebrombaugh/d150.html

I'm attaching the short patch availible at the above page.
Comment 1 Frank Sweetser 2002-08-25 19:53:48 EDT
Created attachment 72884 [details]
Patch for broken Olympus USB digital cameras
Comment 2 Pete Zaitcev 2002-08-26 11:52:31 EDT
From:     Matthew Dharm <mdharm-usb@one-eyed-alien.net>
Date:     2001-06-15 22:07:46

I'm sending this message so it will be picked up into the various archives
and web search engines.

Apparently, Olympus makes a camera with USB capability that identifies
itself as the C-1 -- Vendor=07b4 and ProdID=0102

This device is advertised with as a mass-storage compliant device, but it
is not.  It sends malformed status packets which look to the driver like a
multiple-bit error on the wire, and thus does not work with the standard
Linux driver.

Reports indicate that the Windows drivers do not perform the same,
recommended, checks for data integrity that Linux does, so it does not
notice this problem.

I'm not planning on merging a fix for this into any future kernel.  The
level of deviation from the published specification is too high.  The
amount of shock and amazement on the DWG mailing list when I brought this
to their attention was amazing.

However, if you would like your device to work, then you simply need to go
into drivers/usb/transport.h and change the #define US_BULK_CS_SIGN from
0x53425355 to 0x55425355.  Note, however, that this may disable all your
other USB storage devices -- all devices that use the bulk-only transport
will be affected.

Matt Dharm
Comment 3 Pete Zaitcev 2003-05-23 18:31:08 EDT
<zaitcev> gregkh: Are you going to propagate Olympus fix to 2.4?
<gregkh> zaitcev: yeah, I will after 2.4.21 is out, is that ok?
<zaitcev> gregkh: Also, was it your intention to overrule Matt Dharm's
opposition in Olympus case, or I missed his agreement?
<gregkh> zaitcev: no, I didn't know he objected to it.  Hm...  The patch came
from vojtech so that's two distros against him :)
<zaitcev> Not that I mind the patch, really.
<gregkh> zaitcev: I don't either, we have hacks to get other broken hardware to
work...
<zaitcev> Anyway, if you promise to overrule his opposition, I may claim
"upstream buy-in" and ship the patch.
<gregkh> hm, looks like I didn't add the patch to the 2.4 tree, I'll go do that
now...
<gregkh> zaitcev: ship it, I'll overrule :)
<zaitcev> Weee
Comment 4 Pete Zaitcev 2003-05-25 20:55:39 EDT
2.4.20-16.7+
Comment 5 Arjan van de Ven 2003-06-03 06:16:13 EDT
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2003-187.html

Note You need to log in before you can comment on or make changes to this bug.